<?php	
/**
 * All function.
 *
 * @package SweetRice
 * @SweetRice core.
 * @since 0.5.4
 */
	defined('VALID_INCLUDE') or die();
	function do_data($a,$filterData)
	{
		foreach($a as $key=>$val)
		{
			if(!is_array($val))
			{
				switch($filterData)
				{
					case 'public':
						$a[$key] = db_escape(trim(clean_quotes($val)));
					break;
					case 'privacy':
						$a[$key] = trim(clean_quotes($val));
					break;
				}
			}
		}
		return $a;
	}
	function escape_string($str)
	{
		return htmlspecialchars($str,ENT_QUOTES);
	}
	function clean_quotes($str)
	{
		if(get_magic_quotes_gpc())
		{
			$str = str_replace(array('\\\'','\\"','\\\\'),array('\'','"','\\'),$str);
		}
		return $str;
	}
	function db_escape($str)
	{
		global $database_type;
		switch($database_type)
		{
			case 'sqlite':
				return sqlite_escape_string($str);
			break;
			case 'pgsql':
				return pg_escape_string($str);
			break;
			default:
				return addslashes($str);
		}
	}
	if (!function_exists('htmlspecialchars_decode')) {
		function htmlspecialchars_decode($str,$quote_style)
		{
			$_str = array('&amp;','&quot;','&#039;','&lt;','&gt;');
			$str_ = array('&','"','\'','<','>');
			return str_replace($_str,$str_,$str);
		}
	}
	function show_link_page($cat_link,$sys_name,$url_rewrite){
	if($url_rewrite)
	{
		if($cat_link)
		{
			return $cat_link.'/'.$sys_name.'/';
		}else
		{
			return $sys_name.'.html';
		}
	}else
	{
		return '?action=view&sys-name='.$sys_name;

	}
	}
	function show_link_page_xml($sys_name,$url_rewrite){
	if($url_rewrite)
	{
			return 'rssfeed-'.$sys_name.'.xml';
	}else
	{
		return '?action=rssfeed&type=entry&sys-name='.$sys_name;

	}
	}
	function show_link_cat($category,$p='',$url_rewrite)
	{
		if($url_rewrite)
		{
			return $category.'/'.($p>1?$p.'/':'');
		}else
		{
			return '?action=category&c='.$category.($p>1?'&p='.$p:'');
		}
	}
	function show_link_cat_xml($category,$url_rewrite)
	{
		if($url_rewrite)
		{
			return 'cat-rssfeed-'.$category.'.xml';
		}else
		{
			return '?action=rssfeed&type=category&c='.$category;
		}
	}
	function show_link_tag($tag,$url_rewrite)
	{
		if($url_rewrite)
		{
			return 'tags/'.rawurlencode($tag).'/'.($p>0?$p.'/':'');
		}else
		{
			return '?action=tags&tag='.rawurlencode($tag).($p>1?'&p='.$p:'');
		}
	}
	function show_link_comment($post,$url_rewrite,$p)
	{
		if($url_rewrite)
		{
			return 'comment/'.$post.'/'.($p>1?$p.'/':'');
		}else
		{
			return '?action=show_comment&post='.$post.($p>1?'&p='.$p:'');
		}
	}
	function show_link_attachment($file_name,$url_rewrite)
	{
		if($url_rewrite)
		{
			return 'attachment/'.$file_name.'/';
		}else
		{
			return '?action=attachment&file_name='.$file_name;
		}
	}
	function checkemail($email)
	{
		$email = strtolower($email);
		return preg_match("/^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z][0-9a-zA-Z-]*\.)+[a-zA-Z]{2,3}$/",$email);
	}
	function my_post($to,$subject,$mail_text,$mail_html,$from_mail,$from_name,$mime_boundary)
	{
		$charset = 'UTF-8';
		$from_name = '=?'.$charset.'?B?'.base64_encode($from_name).'?=';
		$subject = '=?'.$charset.'?B?'.base64_encode($subject).'?=';
		$headers = "From: ".$from_name." <".$from_mail.">\n";
		$headers .= "MIME-Version: 1.0\n";
		$headers .= "Content-Type: multipart/alternative; boundary=\"$mime_boundary\"\n";

		# -=-=-=- TEXT EMAIL PART

		$message = "--$mime_boundary\n";
		$message .= "Content-Type: text/plain; charset=".$charset."\n";
		$message .= "Content-Transfer-Encoding: 8bit\n\n";

		$message .= $mail_text;
		$message .= "\n\n";

		# -=-=-=- HTML EMAIL PART
		 
		$message .= "--$mime_boundary\n";
		$message .= "Content-Type: text/html; charset=".$charset."\n";
		$message .= "Content-Transfer-Encoding: 8bit\n\n";

		$message .= $mail_html;
		$message .= "\n";

		# -=-=-=- FINAL BOUNDARY

		$message .= "--$mime_boundary--\n\n";

		# -=-=-=- SEND MAIL

		$mail_sent = mail( $to, $subject, $message, $headers );
		$error = $mail_sent.'1';
		return $error;
	}
	function js_unescape($str)
		{
				$ret = '';
				$len = strlen($str);

				for ($i = 0; $i < $len; $i++)
				{
						if ($str[$i] == '%' && $str[$i+1] == 'u')
						{
								$val = hexdec(substr($str, $i+2, 4));

								if ($val < 0x7f) $ret .= chr($val);
								else if($val < 0x800) $ret .= chr(0xc0|($val>>6)).chr(0x80|($val&0x3f));
								else $ret .= chr(0xe0|($val>>12)).chr(0x80|(($val>>6)&0x3f)).chr(0x80|($val&0x3f));

								$i += 5;
						}
						else if ($str[$i] == '%')
						{
								$ret .= urldecode(substr($str, $i, 3));
								$i += 2;
						}
						else $ret .= $str[$i];
				}
				return $ret;
		}
	function sweetrice_cache($cache_link,$data,$cache_type)
	{
		global $root_dir,$cache,$cache_expired;
		if($cache)
		{
			if(!file_exists($root_dir.'inc/cache/'))
			{
				mkdir($root_dir.'inc/cache/',0777);
			}
			if(!file_exists($root_dir.'inc/cache/'.$cache_link)||(time()-filemtime($root_dir.'inc/cache/'.$cache_link)>$cache_expired&&$cache_expired!=0))
			{
				switch($cache_type)
				{
					case 'db_array':
						foreach($data as $key=>$val)
						{
							$cache_data .= $key.'^'.rawurlencode($val).'|';
						}
					break;
					case 'db_arrays':
						foreach($data as $val)
						{
							foreach($val as $_key=>$_val)
							{
								$cache_data .= $_key.'^'.rawurlencode($_val).'|';
							}
							$cache_data .= '#';
						}
					break;
					case 'db_total':
						$cache_data = $data;
					break;
				}
				file_put_contents($root_dir.'inc/cache/'.$cache_link,$cache_data);
				return ;
			}
		}else
		{
			return ;
		}
	}
	function sweetrice_cached($cache_link,$cache_type)
	{
		global $root_dir,$cache,$cache_expired;
		if($cache)
		{
			if(file_exists($root_dir.'inc/cache/'.$cache_link)&&(time()-@filemtime($root_dir.'inc/cache/'.$cache_link)<=$cache_expired||$cache_expired==0))
			{
				$cache_data = file_get_contents($root_dir.'inc/cache/'.$cache_link);
				switch($cache_type)
				{
					case 'db_array':
						$cache_data = explode('|',$cache_data);
						foreach($cache_data as $val)
						{
							if(trim($val))
							{
								$tmp = explode('^',$val);
								$row[$tmp[0]] = rawurldecode($tmp[1]);
							}
						}
						return $row;
					break;
					case 'db_arrays':
						$cache_data = explode('#',$cache_data);
						foreach($cache_data as $val)
						{
							if(trim($val))
							{
								$_row = array();
								$tmp = explode('|',$val);
								foreach($tmp as $_val)
								{
									if(trim($_val))
									{
										$_tmp = explode('^',$_val);
										$_row[$_tmp[0]] = rawurldecode($_tmp[1]);
									}
								}
								$row[] = $_row;
							}
						}
						return $row;
					break;
					case 'db_total':
						return $cache_data;
					break;	
				}
			}else
			{
				return false;
			}
		}else
		{
			return false;
		}
	}
	function db_insert($table,$_id,$_key,$_val,$return_no=false)
	{
		$_id[1] = intval($_id[1]);
		global $database_type;
		switch($database_type)
		{
			case 'sqlite':
				$_key = '"'.implode('","',$_key).'"';
				$_val = "'".implode("','",$_val)."'";
				if($_id[0]&&$_id[1]>0)
				{
					$sql = "REPLACE INTO \"".$table."\" (\"".$_id[0]."\",".$_key.")VALUES('".$_id[1]."',".$_val.")";
				}elseif($_id[0])
				{
					$sql = "REPLACE INTO \"".$table."\"(\"".$_id[0]."\",".$_key.")VALUES(NULL,".$_val.")";
				}else
				{
					$sql = "REPLACE INTO \"".$table."\"(".$_key.")VALUES(".$_val.")";
				}
				global $db;
				return sqlite_dbinsert($db,$sql,$_id[0]);
			break;
			case 'pgsql':
				if($_id[0]&&$_id[1]>0)
				{
					$total = db_total("SELECT COUNT(*) FROM \"".$table."\" WHERE \"".$_id[0]."\" = '".$_id[1]."'");
					if($total==1)
					{
						$_sql = " SET ";
						for($i=0; $i<count($_key); $i++)
						{
							if($i==0)
							{
								$_sql .= " \"".$_key[$i]."\" = '".$_val[$i]."' ";
							}else
							{
								$_sql .= " , \"".$_key[$i]."\" = '".$_val[$i]."' ";
							}
						}
						$sql = "UPDATE \"".$table."\" ".$_sql." WHERE \"".$_id[0]."\" = '".$_id[1]."'";
					}else
					{
						$_key = '"'.implode('","',$_key).'"';
						$_val = "'".implode("','",$_val)."'";
						$sql = "INSERT INTO \"".$table."\"(\"".$_id[0]."\",".$_key.")VALUES('".$_id[1]."',".$_val.")";	
					}
					pg_query($sql);
					return $_id[1];
				}else
				{
					$_key = '"'.implode('","',$_key).'"';
					$_val = "'".implode("','",$_val)."'";
					if($_id[0])
					{
						$last_id = db_array("SELECT \"".$_id[0]."\" FROM \"".$table."\" ORDER BY \"".$_id[0]."\" DESC LIMIT 1 ");
						$last_id = $last_id[$_id[0]] + 1;
						$sql = "INSERT INTO \"".$table."\"(\"".$_id[0]."\",".$_key.")VALUES('$last_id',".$_val.")";	
					}else
					{
						$sql = "INSERT INTO \"".$table."\"(".$_key.")VALUES(".$_val.")";	
					}
					pg_query($sql);
					if(!$return_no&&$_id[0])
					{
						$row = db_array("SELECT \"".$_id[0]."\" FROM \"".$table."\" ORDER BY \"".$_id[0]."\" DESC LIMIT 1 ");
						return $row[$_id[0]];
					}else
					{
						return true;
					}
				}
			break;
			default:
				$_key = '`'.implode('`,`',$_key).'`';
				$_val = "'".implode("','",$_val)."'";
				if($_id[0])
				{
					$sql = "REPLACE INTO `".$table."`(`".$_id[0]."`,".$_key.")VALUES('".$_id[1]."',".$_val.")";
				}else
				{
					$sql = "REPLACE INTO `".$table."`(".$_key.")VALUES(".$_val.")";
				}
				mysql_query($sql);
				if($_id[0])
				{
					return mysql_insert_id();
				}else
				{
					return true;
				}
		}
	}
	function db_query($sql)
	{
		global $database_type;
		switch($database_type)
		{
			case 'sqlite':
				$sql = str_replace('`','"',$sql);
				global $db;
				return sqlite_dbquery($db,$sql);
			break;
			case 'pgsql':
				$sql = str_replace('`','"',$sql);
				$res = pg_query($sql);
				return pg_last_error();
			break;
			default:
				mysql_query($sql);
				return mysql_error();
		}
	}
	function db_arrays($sql,$type = 'ASSOC')
	{
		$cache_link = 'db_arrays_'.md5($sql);
		$cache_data = sweetrice_cached($cache_link,'db_arrays');
		if($cache_data)
		{
			return $cache_data;
		}else
		{
			$rows = array();
			global $database_type;
			switch($database_type)
			{
				case 'sqlite':
					$sql = str_replace('`','"',$sql);
					global $db;
					$rows = sqlite_dbarrays($db,$sql,$type);
				break;
				case 'pgsql':
					$sql = str_replace('`','"',$sql);
					$res = pg_query($sql);
					while($row = pg_fetch_array($res,null,$type=='BOTH'?PGSQL_BOTH:PGSQL_ASSOC))
					{
						$rows[] = $row;
					}
				break;
				default:
					$res = mysql_query($sql);
					while($row = mysql_fetch_array($res,$type=='BOTH'?MYSQL_BOTH:MYSQL_ASSOC))
					{
						$rows[] = $row;
					}
			}
			sweetrice_cache($cache_link,$rows,'db_arrays');
			return $rows;
		}
	}
	function db_array($sql,$type = 'ASSOC')
	{
		$cache_link = 'db_array_'.md5($sql);
		$cache_data = sweetrice_cached($cache_link,'db_array');
		if($cache_data)
		{
			return $cache_data;
		}else
		{
			global $database_type;
			switch($database_type)
			{
				case 'sqlite':
					$sql = str_replace('`','"',$sql);
					global $db;
					$row = sqlite_dbarray($db,$sql,$type);
				break;
				case 'pgsql':
					$sql = str_replace('`','"',$sql);
					$row = pg_fetch_array(pg_query($sql),null,$type=='BOTH'?PGSQL_BOTH:PGSQL_ASSOC);
				break;
				default:
					$row = mysql_fetch_array(mysql_query($sql),$type=='BOTH'?MYSQL_BOTH:MYSQL_ASSOC);
			}
			sweetrice_cache($cache_link,$row,'db_array');
			return $row;
		}
	}
	function db_total($sql)
	{
		$cache_link = 'db_total_'.md5($sql);
		$cache_data = sweetrice_cached($cache_link,'db_total');
		if($cache_data)
		{
			return $cache_data;
		}else
		{
			global $database_type;
			switch($database_type)
			{
				case 'sqlite':
					$sql = str_replace('`','"',$sql);
					global $db;
					$total =  sqlite_dbtotal($db,$sql);
				break;
				case 'pgsql':
					$sql = str_replace('`','"',$sql);
					$row = pg_fetch_row(pg_query($sql));
					$total = $row[0];
				break;
				default:
					$row = mysql_fetch_row(mysql_query($sql));
					$total = $row[0];
			}
			sweetrice_cache($cache_link,$total,'db_total');
			return $total;			
		}
	}
	function sqlite_dbhandle($dbname)
	{
		global $sqlite_driver;
		if($sqlite_driver=='sqlite')
		{
			$db = sqlite_open($dbname);
		}else
		{
			if(!file_exists($dbname))
			{
				$handle = fopen($dbname,'w+');
				fclose($handle);
			}
			$db = new PDO('sqlite:'.$dbname);
		}
		return $db;
	}
	function sqlite_dbinsert($db,$sql,$id)
	{
		global $sqlite_driver;
		if($sqlite_driver=='sqlite')
		{
			sqlite_query($db,$sql);
			if($id)
			{
				return sqlite_last_insert_rowid($db);
			}else
			{
				return true;
			}
		}else
		{			
			$db->query($sql);
			if($id)
			{
				return $db->lastInsertId();
			}else
			{
				return true;
			}

		}
	}
	function sqlite_dbquery($db,$sql)
	{
		global $sqlite_driver;
		if($sqlite_driver=='sqlite')
		{
			sqlite_query($db,$sql,null,$error);
			if($error)
			{
				return $error;
			}else
			{
				return '';
			}			
		}else
		{
			$db->query($sql);
			$error = $db->errorInfo();
			if($error[0]!='0000')
			{
				return $error[2];
			}else
			{
				return '';
			}
		}
	}
	function sqlite_dbarray($db,$sql,$type)
	{
		global $sqlite_driver;
		if($sqlite_driver=='sqlite')
		{
			return clean_dbData(sqlite_fetch_array(sqlite_query($db,$sql),$type=='BOTH'?SQLITE_BOTH:SQLITE_ASSOC));			
		}else
		{
			$row = $db->query($sql)->fetchAll($type=='BOTH'?SQLITE_BOTH:PDO::FETCH_ASSOC);
			return $row[0];
		}
	}
	function sqlite_dbarrays($db,$sql,$type)
	{
		global $sqlite_driver;
		if($sqlite_driver=='sqlite')
		{
			$res = sqlite_query($db,$sql);
			while($row = sqlite_fetch_array($res,$type=='BOTH'?SQLITE_BOTH:SQLITE_ASSOC))
			{
				$rows[] = clean_dbData($row);
			}
		}else
		{
			$rows = $db->query($sql)->fetchAll($type=='BOTH'?SQLITE_BOTH:PDO::FETCH_ASSOC);
		}
		return $rows;
	}
	function sqlite_dbtotal($db,$sql)
	{
		global $sqlite_driver;
		if($sqlite_driver=='sqlite')
		{
			$row = sqlite_fetch_array(sqlite_query($db,$sql));
			return $row[0];
		}else
		{
			$row = $db->query($sql)->fetchAll();
			$total = $row[0][0];	
			return $total;			
		}
	}
	function clean_dbData($row)
	{
		if(!$row)
		{
			$row = array();
		}
		foreach($row as $key=>$val)
		{
			$row[trim($key,'"')] = $val;
		}
		return $row;
	}
	function db_list()
	{
		global $database_type,$db_left;
		switch($database_type)
		{
			case 'sqlite':
					$table_array = db_arrays("select name from sqlite_master where name LIKE '".$db_left.'_'."%' AND name NOT LIKE 'sqlite_%'",'BOTH');
					foreach($table_array as $val)
					{
						$table_list[] = $val[0];
					}
			break;
			case 'mysql':
					$table_array = db_arrays("SHOW TABLES",'BOTH');
					foreach($table_array as $val)
					{
						if(substr($val[0],0,(strlen($db_left)+1))==$db_left.'_')
						{
							$table_list[] = $val[0];
						}
					}
			break;
			case 'pgsql':
					$table_array = db_arrays("SELECT tablename FROM pg_tables  WHERE tablename LIKE '".$db_left."_%' ;");
					foreach($table_array as $val)
					{
						$table_list[] = $val['tablename'];
					}
			break;
		}
		return $table_list;
	}
	function cn_substr($str,$start,$len)
	{
		$str = iconv('UTF-8','GB2312',$str);
		$tmpstr = "";
		$strlen = $start + $len;
		for($i = 0; $i < $strlen; $i++){
		   if(ord(substr($str, $i, 1)) > 0xa0){
			$tmpstr .= substr($str, $i, 2);
			$i++;
		   }else
			$tmpstr .= substr($str, $i, 1);
		}
		return iconv('GB2312','UTF-8',$tmpstr);
	}
	function bc_out()
	{
		if(!headers_sent()&&extension_loaded("zlib")&&strpos($_SERVER["HTTP_ACCEPT_ENCODING"],"gzip")!==false)
		{
			ob_start(ob_start("ob_gzhandler"));
		}else
		{
			ob_start();
		}
	}
	function bc_flush()
	{
		ob_end_flush();
	}
	function upload_($f,$dest_dir,$new_file,$old_file)
		{
			$file_type='.php';
			$fileext='.'.end(explode('.',$f['name']));
				if($f['name']&&strtolower($fileext)!=$file_type)
				{
					$dest=$dest_dir.$new_file;
					$r=move_uploaded_file($f['tmp_name'],$dest);
					if($r)
					{
						chmod($dest,0777);
					}
					if($old_file&&file_exists($dest_dir.$old_file)&&$old_file!=$new_file)
					{
						unlink($dest_dir.$old_file);
					}
					return $new_file;
				}else
				{
					return $old_file;
				}
		}
	function download($f)
	{
		$data = file_get_contents($f);
		ob_end_clean();
		header('Content-Encoding: none');
		header('Content-Type: '.(strpos($HTTP_SERVER_VARS['HTTP_USER_AGENT'], 'MSIE') ? 'application/octetstream' : 'application/octet-stream'));
		header('Content-Disposition: '.(strpos($HTTP_SERVER_VARS['HTTP_USER_AGENT'], 'MSIE') ? 'inline; ' : 'attachment; ').'filename="'.str_replace('attachment/','',$f));
		header('Content-Length: '.strlen($data));
		header('Pragma: no-cache');
		header('Expires: 0');
		die($data);
	}
	function filesize2print($fs)
	{
		if($fs>1073741824)
		{
			return number_format(($fs/1073741824),2,'.','').'G';
		}elseif($fs>1048576)
		{
			return number_format(($fs/1048576),2,'.','').'M';
		}elseif($fs>1024)
		{
			return number_format(($fs/1024),2,'.','').'k';
		}else
		{
			return $fs.'B';
		}
		
	}
	function sweetrice_version()
	{
		$lastest_ = get_data_from_url('http://www.basic-cms.org/lastest.txt');
		$current_ = file_get_contents('../inc/lastest.txt');
		if($current_)
		{
			$str = 'Current version:'.$current_.' ';
			$last_ = str_replace('.','',ltrim($lastest_,'0'));
		}
		if($lastest_)
		{
			$str .= 'Lastest version:'.$lastest_.' ';
			$curr_ = str_replace('.','',ltrim($current_,'0'));
		}
		if($last_>$curr_)
		{
			$update = true;
		}
		echo($str);
		return $update;
	}
	function mod_date($d)
	{
		if(!$d)
		{
			$d = time();
		}
		if(intval(phpversion())>=5)
		{
			$mod_date = date('c',$d);
		}else
		{
			$mod_date = date('Y-m-d',$d).'T'.date('HisO',$d);
		}
		return $mod_date;
	}

	function user_track()
	{
		$ip = getenv("REMOTE_ADDR");
		$user_from = $_SERVER["HTTP_REFERER"];
		$this_page = $_SERVER["REQUEST_URI"];
		$user_browser = $_SERVER["HTTP_USER_AGENT"];
		$browsers = array('ie7'=>'MSIE 7.0','ie8'=>'MSIE 8.0','ie6'=>'MSIE 6.0','firefox'=>'Firefox','opera'=>'Opera','chrome'=>'Chrome','safari'=>'Safari');
		foreach($browsers as $val)
		{
			if(strpos($user_browser,$val)!==false)
			{
				$user_browser = $val;
				$is_browser = true;
				break;
			}
		}
		if(!$is_browser)
		{
			$user_browser = 'Other';
		}
		
		if($user_from=='')
		{
			$user_from = $this_page;
		}
		$dbname = 'inc/user_track.db';
		if(!file_exists($dbname))
		{
			$new_track = true;
		}
		$db_track = sqlite_dbhandle($dbname);
		if($new_track)
		{
			sqlite_dbquery($db_track,"CREATE TABLE user_agent (id INTEGER PRIMARY KEY ,ip varchar(15) ,user_from varchar(255) ,this_page varchar(255),user_browser varchar(255),time integer)");
		}
		sqlite_dbquery($db_track,"INSERT INTO user_agent (id,ip,user_from,this_page,user_browser,time)VALUES(NULL,'$ip','$user_from','$this_page','$user_browser','".time()."')");
		return ;
	}
	function get_limit_sql($page_start,$page_limit)
	{
		global $database_type;
		if($database_type=='pgsql')
		{
			return "LIMIT $page_limit OFFSET $page_start";
		}else
		{
			return "LIMIT $page_start , $page_limit ";
		}
	}
	function get_template($theme_dir,$type)
	{
		$theme_config = file($theme_dir.'theme.config');
		foreach($theme_config as $val)
		{
			if(trim($val))
			{
				$tmp = explode('|',$val);
				$templates[str_replace('inc/','',trim($tmp[1]))] = $tmp[0];
			}
		}
		$d = dir($theme_dir);
		while (false !== ($entry = $d->read())) {
			 if($entry!='.'&&$entry!='..'&&$entry!='theme.config'&&!is_dir($theme_dir.$entry))
			 {
				$str = file_get_contents($theme_dir.$entry);
				$pos_no = strpos($str,' * '.$type.' Template:');
				if($pos_no!==false)
				{
					$tmp = substr($str,$pos_no+strlen(' * '.$type.' Template:'));
					$tmp = trim(substr($tmp,0,strpos($tmp,"*")));
					$template[$templates[$entry]?'default':substr($theme_dir.$entry,3)] = $tmp;
				}
			 }
		}
		$d->close();
		return $template;
	}
	function get_AllTemplate($theme_dir)
	{
		$theme_config = file($theme_dir.'theme.config');
		foreach($theme_config as $val)
		{
			if(trim($val))
			{
				$tmp = explode('|',$val);
				if($theme_dir == '../inc/')
				{
					$templates['../'.trim($tmp[1])] = $tmp[0];
				}else
				{
					$templates[$theme_dir.trim($tmp[1])] = $tmp[0];
				}
			}
		}
		$d = dir($theme_dir);
		while (false !== ($entry = $d->read())) {
			 if($entry!='.'&&$entry!='..'&&$entry!='theme.config'&&!is_dir($theme_dir.$entry)&&!$templates[$theme_dir.$entry])
			 {
				$str = file_get_contents($theme_dir.$entry);
				$is_template = preg_match("/\s*[\sa-zA-Z0-9\-\_]+Template:[\sa-zA-Z0-9\-\_]+template/i",$str);
				if($is_template)
				{
					$tmp = substr($str,strpos($str,'Template:')+9);
					$tmp = trim(trim(substr($tmp,0,strpos($tmp,"*"))),'.');
					$templates[$theme_dir.$entry] = $tmp;
				}
			 }
		}
		$d->close();
		$templates = array_flip($templates);
		return $templates;
	}
	if (!function_exists('exif_imagetype')) {
		function sr_file_type($filename)
		{
			$filetypes = array('GIF'=>'image/gif','JPEG'=>'image/jpge','JPG'=>'image/jpeg','PNG'=>'png','SWF'=>'application/x-shockwave-flash','PSD'=>'image/psd','BMP'=>'image/bmp','TIFF'=>'image/tiff','JPC'=>'application/octet-stream','JP2'=>'image/jp2','JPX'=>'application/octet-stream','JB2'=>'application/octet-stream','SWC'=>'application/x-shockwave-flash','IFF'=>'image/iff','WBMP'=>'image/vnd.wap.wbmp','XBM'=>'image/xbm');
			$file_ext = strtoupper(end(explode('.',$filename)));
			if($filetypes[$file_ext])
			{
				return $filetypes[$file_ext];
			}else
			{
				return 'application/octet-stream';
			}
		}
	}else
	{
		function sr_file_type($filename)
		{
			return image_type_to_mime_type(exif_imagetype($filename));
		}		
	}
	function get_data_from_url($url)
	{
		$allow_url_fopen  = ini_get('allow_url_fopen');
		if($allow_url_fopen)
		{
			$output = file_get_contents($url);
		}else
		{
			
		$url = str_replace('http://','',$url);
		$urls = explode('/',$url);
		$url_str = substr($url,strlen($urls[0]));
			$fp = fsockopen($urls[0], 80, $errno, $errstr, 30);
			if (!$fp) {
					echo "$errstr ($errno)<br />\n";
			} else {
					$out = "GET ".$url_str." HTTP/1.1\r\n";
					$out .= "Host: ".$urls[0]."\r\n";
					$out .= "Connection: Close\r\n\r\n";
					fwrite($fp, $out);
					while (!feof($fp)) {
							$data .= fgets($fp, 1024);
					}
					fclose($fp);
			}
			preg_match("/\r\n\r\n(.+)/is", $data, $out);
			$output = $out[1];
		}
		return $output;
	}
	function _404($tip_404)
	{
		header('HTTP/1.1 404 Page Not Found');
		$tip_404s = array('category'=>'Sorry ,the category does not exists.','entry'=>'Sorry ,the entry does not exists.','attachment'=>'Sorry ,the attachment does not exists.','tags'=>'Sorry ,the tag does not exists.','plugin'=>'Sorry ,the plugin does not exists.');
		include("inc/404.php");
		exit();
	}
	function alert($str)
	{
?>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<script type="text/javascript">
<!--
	alert('<?php echo $str;?>');
//-->
</script>
<?php
	}
	function _goto($url)
	{
?>
<script type="text/javascript">
<!--
	location.href = '<?php echo $url;?>';
//-->
</script>
<?php
	exit();
	}
	function completeInsert($yes_url,$no_url,$tip = CREATE_ANOTHER_ONE)
	{
?>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<script type="text/javascript">
<!--
	if(confirm("<?php echo $tip;?>"))
	{
		location.href="<?php echo $yes_url;?>";
	}else
	{
		location.href="<?php echo $no_url;?>";
	}
//-->
</script>
<?php
	exit();
	}
?>